var client_pet = {
    settings: {
        ajaxUrl: '',
        ajax_form_process: ''
    },
    init: function() {
        client_pet.initDataTable();
    },


    initDataTable: function() {

        var callBack = function() {
            client_pet.initDetail();
        };

        client_pet.dataList = $('#client_pet-datalist').DataTable({
            'processing': true,
            'serverSide': true,
            "lengthChange": false,
            "pageLength": 20,
            'ajax': {
                'url': client_pet.settings.ajaxUrl,
                'data': function(d) {
                    d.url = global.settings.url;
                }
            },
            'deferRender': true,
            'columnDefs': [
                { 'orderable': false, 'targets': 2 },
                { 'searchable': false, 'targets': 2 }
            ],
            drawCallback: function() {
                callBack();
            },
            responsive: {
                details: {
                    renderer: function( api,rowIdx ) {
                        return global.dataTableResponsiveCallBack(api, rowIdx, callBack);
                    }
                }
            }
        });

        $('.content-container').removeClass('has-loading');
        $('.content-container-content').removeClass('hide');
    },

    initDetail: function(){

        $.each($('.href-modal'), function(){
            var _this = $(this);
            _this.unbind('click').bind('click',function(){
                $.ajax({
                    url: _this.data('url') + '?id=' + _this.data('id') ,
                    beforeSend: function(){
    
                        if(!_this.hasClass('fullscreen')){
                            $('.modal').removeClass('modal-fullscreen');
            
                        } else {
                            $('.modal').addClass('modal-fullscreen');
                        }
                    },
                    success: function(r){
                        
                        if(r.success){
                            $('.loading').addClass('hidden');
                            $(".modal-content").html(r.html);
                            $('.modal').modal('show');
        
                        }
                    }
                });
            });
        });
      
    }
};