var lodge_ajax_form = {
    settings: {
        processFormUrl: '',
        clientPetAutoCompleteUrl:'',
        serviceAutocompleteUrl: '',
        userAutocompleteUrl: '',
        formChoices: null,
    },
    init: function(){
        lodge_ajax_form.processForm();
        lodge_ajax_form.bindAutoComplete();
        lodge_ajax_form.addService();
        lodge_ajax_form.remove();
        lodge_ajax_form.loadChildview();

    },
    incrementModalformInputId: function(){
        var form = $('.modal-content').find('form');

        form.find('input, select, hidden').each(
            function(index){  
                var input = $(this);
                $(this).prop('id', input.attr('id') +'_' + 1);
            }
        );
    },
    loadChildview: function(){

        if($('#lodge_form_id').val() != '0'){
            $.ajax({
                url: '/lodge_payment/ajax_index?lodgeId=' + $('#lodge_form_id').val() ,
                success: function(r){
                    if(r.success){
                        
                        $('#paymentTabContainer').html(r.html);
                        
                    } else {
                        $('#paymentTabContainer').html('Something went wrong please try again.');
                    }
                }
            });
        }
    },
    processForm: function(){
        
        $('#form').submit(function(e){
            e.preventDefault();
            _this = $(this);



            if($('#childForm').length){
   
                alert('Please cancel or save payment form before submitting the form again.');
            } else {
              
                var btn = _this.find('button[type=submit]');
                btn.prop('disabled', true);
                var formData = new FormData(_this[0]);
                var modal = $('#modal');

                $.ajax({
                    url:  lodge_ajax_form.settings.processFormUrl,
                    data: formData, 
                    type: "post",
                    cache: false,
                    processData: false,
                    contentType: false, 
                    success: function(r){
                        if(r.success){
                             $('.loading').removeClass('hidden');
                             $("#ui-datepicker-div").remove();
                        
                           $.toaster({ message : r.msg, title : '', priority : 'success' });

                            if(typeof dashboard  != 'undefined'){
                                dashboard.getRoomCardList();
                            }

                            if(r.id){
                                $.ajax({
                                    url: '/lodge/ajax_form',
                                    type: 'POST',
                                    data: { roomId: r.id, action: 'u'},
                                    success: function(r){
                                        if(r.success){
                                       
                                            $('.loading').addClass('hidden');
                                            $(".modal-content").html(r.html);
                                            modal.modal('show');
    
                                        }
                                    }
                                });
                            } else {

                                window.location = '/lodge/pet_hotel';
                            }
                         
                        } else {

                            $.toaster({ message : r.msg, title : '', priority : 'danger' });
                            btn.prop('disabled', false);
                            $('.loading').addClass('hidden');
                        }
                    }
                });
     
            }
        });
    },
    addService: function(){
        $.each($('.href-add'),function(){
            var _this = $(this);
            _this.unbind('click').bind('click',function(){
                var ctr = $('.serviceCtr').length;
                ctr++;
                var _html = '';
                _html+= '<tr class="serviceCtr"><td><a class="remove float-left" href="javascript:void(0);"/><i style="color:red;margin-right:5px;" class="fa fa-times" aria-hidden="true"></i></a>'+'<input style="width:85%;" type="text" class="form-control lodgeService" name="lodge_form[lodgeService]['+ctr+'][service_desc]" id="serviceDesc_'+ctr+'" /><input style="width:85%;" type="hidden" class="form-control" name="lodge_form[lodgeService]['+ctr+'][service]" id="service_'+ctr+'" /></td>';
                _html+= '<td><input style="width:85%;" type="text" class="form-control lodgeService" name="lodge_form[lodgeService]['+ctr+'][staff_desc]" id="staffDesc_'+ctr+'" /><input style="width:85%;" type="hidden" class="form-control" name="lodge_form[lodgeService]['+ctr+'][staff]" id="staff_'+ctr+'" /></td>';
                _html+= '<td><select class="form-control" name="lodge_form[lodgeService]['+ctr+'][status]" />'+lodge_ajax_form.getOptionElem('serviceStatuses')+'</select></td>';
                _html+= '<td style="width:90px;"><input type="text" class="form-control amt" name="lodge_form[lodgeService]['+ctr+'][price]" /></td>';
                $('#' + _this.data('target')).find('tbody').append(_html);
                global.mask();
                
                lodge_ajax_form.remove();
                lodge_ajax_form.bindAutoComplete();
            });
        });
    },
    getOptionElem: function(selectType){
        var _html = '';

        $.each(lodge_ajax_form.settings.formChoices,function(i, obj) {

            if(i == selectType){
                $.each(lodge_ajax_form.settings.formChoices[selectType], function(i){
                    _html+= '<option value="'+i+'">'+i+'</option>';
                });
            }
        });

        return _html;
    },

    bindAutoComplete: function(){
        global.autocomplete.bind(this.settings.clientPetAutoCompleteUrl,'#lodge_form_client_pet_desc','#lodge_form_client_pet');


        $.each($('.lodgeService'),function(i){
            if($('#serviceDesc_' +  (i + 1)).length ){
                global.autocomplete.bind(lodge_ajax_form.settings.serviceAutocompleteUrl,$('#serviceDesc_' +  (i + 1)),$('#service_' +  (i + 1)), {
                    onSelect: function(s){
                        $('#serviceDesc_' +  (i + 1)).parent().parent().find('[name="lodge_form[lodgeService][' +(i + 1)+'][price]"]' ).val(s.price);

                        console.log('[name="lodge_form[lodgeService][' +(i + 1)+'][price]"]');
                    }
                });

            }

            if($('#staffDesc_' +  (i + 1)).length ){
                global.autocomplete.bind(lodge_ajax_form.settings.userAutocompleteUrl,$('#staffDesc_' +  (i + 1)),$('#staff_' +  (i + 1)));

            }
        });
    },
    
    remove: function(){

        $.each($('.remove'),function(){
            var _this = $(this);
            _this.unbind('click').bind('click',function(){
                 _this.closest('tr').remove();     
            });
        });
    },
}