<?php

namespace App\Controller;

use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\JsonResponse;
use Symfony\Component\Routing\Annotation\Route;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\RedirectResponse;

use App\Service\AuthService;
use App\Entity\BillingEntity;
use App\Entity\BillingServiceEntity;
use App\Entity\ServiceEntity;
use App\Entity\UserEntity;
use App\Entity\RoomEntity;
use App\Entity\SmsEntity;
use App\Entity\BranchSmsEntity;
use App\Form\BillingForm;


/**
 * @Route("/billing")
 */
class BillingController extends AbstractController
{

   /**
    * @Route("/lodge", name="billing_lodge")
    */
    public function lodge(Request $request, AuthService $authService)
    {
       
       if(!$authService->isLoggedIn()) return $authService->redirectToLogin();
       if(!$authService->isUserHasAccesses(array('Billing'))) return $authService->redirectToHome();
       
       $page_title = ' Billing'; 
       return $this->render('Billing/lodge.html.twig', [ 
          'page_title' => $page_title, 
          'javascripts' => array('/plugins/datatables/jquery.dataTables.js','/js/billing/index.js') ]
       );
    } 

    /**
    * @Route("/grooming", name="billing_grooming")
    */
    public function grooming(Request $request, AuthService $authService)
    {
       
       if(!$authService->isLoggedIn()) return $authService->redirectToLogin();
       if(!$authService->isUserHasAccesses(array('Billing'))) return $authService->redirectToHome();
       
       $page_title = ' Billing'; 
       return $this->render('Billing/grooming.html.twig', [ 
          'page_title' => $page_title, 
          'javascripts' => array('/plugins/datatables/jquery.dataTables.js','/js/billing/index.js') ]
       );
    } 

    
}
