<?php

namespace App\Controller;

use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\JsonResponse;
use Symfony\Component\Routing\Annotation\Route;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\RedirectResponse;
use Knp\Snappy\Pdf;
use Symfony\Component\HttpFoundation\Response;

use App\Entity\BranchVariableEntity;
use App\Entity\ClientAccountPaymentEntity;
use App\Entity\ClientAccountEntity;
use App\Entity\ClientAccountBillingEntity;
use App\Entity\PurokEntity;


use App\Service\AuthService;

/**
 * @Route("/dashboard")
 */
class DashboardController extends AbstractController
{
    /**
     * @Route("", name="dashboard_index")
     */
    public function index(Request $request, AuthService $authService)
    {

        if(!$authService->isLoggedIn()) return $authService->redirectToLogin();

         $userSession = $this->get('session')->get('userData');

         if($userSession['currentModule'] == 'hotel'){
            
            // $page_title = ' Lodge Dashboard'; 
            // return $this->render('Lodge/dashboard.html.twig', [ 
            //    'page_title' => $page_title, 
            //    'javascripts' => array('/js/lodge/dashboard.js') ]
            // );

           return $this->redirect($this->generateUrl('lodge_pet_hotel'), 302);
         } else {

            // $page_title = ' Grooming Dashboard'; 
            // return $this->render('Grooming/dashboard.html.twig', [ 
            //     'page_title' => $page_title, 
            //     'javascripts' => array('/js/grooming/dashboard.js') ]
            // );

            return  $this->redirect($this->generateUrl('grooming_index'), 302);

         }



    }    
}
