<?php

namespace App\Entity;

use App\Entity\Base\BaseEntity;

use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\ORM\Mapping as ORM;
use Symfony\Component\Form\Extension\Core\DataTransformer\DateTimeToStringTransformer;

/**
 * @ORM\Entity(repositoryClass="App\Repository\BranchSmsRepository")
 * @ORM\Table(name="branch_sms")
 * @ORM\HasLifecycleCallbacks()
 */

class BranchSmsEntity extends BaseEntity
{
    /**
     * @ORM\Column(type="bigint")
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="AUTO")
     */
    protected $id;
    
    /**
     * @ORM\Column(name="message", type="text")
     */
    protected $message;

     /**
     * @ORM\Column(name="contact_no", type="string", nullable=true)
     */
    protected $contactNo;

    /**
     * @ORM\Column(name="status", type="string")
     */
    protected $status;

    /**
     * @ORM\Column(name="sent_ctr", type="string", nullable=true)
     */
    protected $sentCtr;

    /**
     * @ORM\Column(name="send_at", type="datetime", nullable=true)
     */
    protected $sendAt;

    /**
     * @ORM\ManyToOne(targetEntity="LodgeServiceEntity", inversedBy="branchSmss")
     * @ORM\JoinColumn(name="lodge_service_id", referencedColumnName="id", nullable=true)
     */
    protected $lodgeService;

    /**
     * @ORM\ManyToOne(targetEntity="LodgeEntity", inversedBy="branchSmss")
     * @ORM\JoinColumn(name="lodge_id", referencedColumnName="id", nullable=true)
     */
    protected $lodge;

    /**
     * @ORM\ManyToOne(targetEntity="GroomingServiceEntity", inversedBy="branchSmss")
     * @ORM\JoinColumn(name="grooming_service_id", referencedColumnName="id", nullable=true)
     */
    protected $groomingService;

    /**
     * @ORM\ManyToOne(targetEntity="GroomingEntity", inversedBy="branchSmss")
     * @ORM\JoinColumn(name="grooming_id", referencedColumnName="id", nullable=true)
     */
    protected $grooming;

    /**
     * @ORM\ManyToOne(targetEntity="BranchEntity", inversedBy="branchSmss")
     * @ORM\JoinColumn(name="branch_id", referencedColumnName="id", nullable=true)
     */
    protected $branch;

    /**
     * @ORM\ManyToOne(targetEntity="SmsEntity", inversedBy="branchSmss")
     * @ORM\JoinColumn(name="sms_id", referencedColumnName="id", nullable=true)
     */
    protected $sms;

   


    public function __construct($data = null)
    {

    }

    /*--------------------------------------------------------------------------------------------------------*/
    /*					BranchSms Defined Setters and Getters													  */
    /*--------------------------------------------------------------------------------------------------------*/

/**
     * Set isDeleted
     *
     * @param boolean $isDeleted
     *
     * @return BranchSmsEntity
     */
    public function setIsDeleted($isDeleted)
    {
        $this->isDeleted = $isDeleted;

        return $this;
    }
    /*--------------------------------------------------------------------------------------------------------*/
    /*					    Defined Setters and Getters													      */
    /*--------------------------------------------------------------------------------------------------------*/

    public function getId(): ?string
    {
        return $this->id;
    }

    public function getMessage(): ?string
    {
        return $this->message;
    }

    public function setMessage(string $message): self
    {
        $this->message = $message;

        return $this;
    }

    public function getContactNo(): ?string
    {
        return $this->contactNo;
    }

    public function setContactNo(?string $contactNo): self
    {
        $this->contactNo = $contactNo;

        return $this;
    }

    public function getStatus(): ?string
    {
        return $this->status;
    }

    public function setStatus(string $status): self
    {
        $this->status = $status;

        return $this;
    }

    public function getSentCtr(): ?string
    {
        return $this->sentCtr;
    }

    public function setSentCtr(?string $sentCtr): self
    {
        $this->sentCtr = $sentCtr;

        return $this;
    }

    public function getSendAt(): ?\DateTimeInterface
    {
        return $this->sendAt;
    }

    public function setSendAt(?\DateTimeInterface $sendAt): self
    {
        $this->sendAt = $sendAt;

        return $this;
    }

    public function getLodgeService(): ?LodgeServiceEntity
    {
        return $this->lodgeService;
    }

    public function setLodgeService(?LodgeServiceEntity $lodgeService): self
    {
        $this->lodgeService = $lodgeService;

        return $this;
    }

    public function getLodge(): ?LodgeEntity
    {
        return $this->lodge;
    }

    public function setLodge(?LodgeEntity $lodge): self
    {
        $this->lodge = $lodge;

        return $this;
    }

    public function getGroomingService(): ?GroomingServiceEntity
    {
        return $this->groomingService;
    }

    public function setGroomingService(?GroomingServiceEntity $groomingService): self
    {
        $this->groomingService = $groomingService;

        return $this;
    }

    public function getGrooming(): ?GroomingEntity
    {
        return $this->grooming;
    }

    public function setGrooming(?GroomingEntity $grooming): self
    {
        $this->grooming = $grooming;

        return $this;
    }

    public function getBranch(): ?BranchEntity
    {
        return $this->branch;
    }

    public function setBranch(?BranchEntity $branch): self
    {
        $this->branch = $branch;

        return $this;
    }

    public function getSms(): ?SmsEntity
    {
        return $this->sms;
    }

    public function setSms(?SmsEntity $sms): self
    {
        $this->sms = $sms;

        return $this;
    }


    



    

    

   
}
