<?php

namespace App\Repository;

use App\Entity\ClienPetEntity;
use App\Entity\BranchEntity;



/**
 * ClientPetRepository
 *
 * This class was generated by the Doctrine ORM. Add your own custom
 * repository methods below.
 */
class ClientPetRepository extends \Doctrine\ORM\EntityRepository
{


    public function ajax_list(array $get, array $userData){
        $columns = array(
          
            array('CONCAT(c.`first_name`, " ", c.`last_name`)', 'CONCAT(c.`first_name`, " ", c.`last_name`)', 'client'),
            array('cp.`pet_name`', 'cp.`pet_name`', 'clientPet'),
            array('cp.`id`', "cp.`id`", 'id'),


        );
        $asColumns = array();

        $select = "SELECT";
        $from = "FROM `client_pet` cp";
        $joins = "LEFT JOIN `client` c ON c.`id` = cp.`client_id`";
        $sqlWhere = " WHERE (cp.`is_deleted` = 0 OR  cp.`is_deleted` IS NULL) ";
        $groupBy = "";
        $orderBy = "";
        $limit = "";
        $stmtParams = array();
       
        if($userData['type'] != 'Super Admin'){
            $sqlWhere .= ' AND c.`branch_id` = ' . base64_decode($userData['branchId']);
        }

        foreach($columns as $key => $column) {
            $select .= ($key > 0 ? ', ' : ' ') . $column[1] . (isset($column[2]) ? ' AS ' . $column[2] : '');
        }

        /*
         * Ordering
         */
        foreach($get['columns'] as $key => $column) {
            if($column['orderable']=='true') {
                if(isSet($get['order'])) {
                    foreach($get['order'] as $order) {
                        if($order['column']==$key) {
                            $orderBy .= (!empty($orderBy) ? ', ' : 'ORDER BY ') . $columns[$key][0] . (!empty($order['dir']) ? ' ' . $order['dir'] : '');
                        }
                    }
                }
            }
        }

          /*
         * Filtering
         */
        if(!empty($get['q']) && $get['q']){
            $aLikes = array();
            foreach($get['columns'] as $key => $column) {
                if($column['searchable']=='true') {
                    $aLikes[] = $columns[$key][0] . ' LIKE :searchValue';
                }
            }
            foreach($asColumns as $asColumn) {
                $aLikes[] = $asColumn . ' LIKE :searchValue';
            }
            if(count($aLikes)) {
                $sqlWhere .= (!empty($sqlWhere) ? ' AND ' : 'WHERE ') . '(' . implode(' OR ', $aLikes) . ')';
                $stmtParams['searchValue'] = "%" . $get['q'] . "%";
            }
        } else {
            /*
            * Filtering
            */
            if(isset($get['search']) && $get['search']['value'] != ''){
                $aLikes = array();
                foreach($get['columns'] as $key => $column) {
                    if($column['searchable']=='true') {
                        $aLikes[] = $columns[$key][0] . ' LIKE :searchValue';
                    }
                }
                foreach($asColumns as $asColumn) {
                    $aLikes[] = $asColumn . ' LIKE :searchValue';
                }
                if(count($aLikes)) {
                    $sqlWhere .= (!empty($sqlWhere) ? ' AND ' : 'WHERE ') . '(' . implode(' OR ', $aLikes) . ')';
                    $stmtParams['searchValue'] = "%" . $get['search']['value'] . "%";
                }
            }

        }

    
        /* Set Limit and Length */
        if(isset( $get['start'] ) && $get['length'] != '-1'){
            $limit = 'LIMIT ' . (int)$get['start'] . ',' . (int)$get['length'];
        }

        $sql = "$select $from $joins $sqlWhere $groupBy $orderBy";
        $query = $this->getEntityManager()->getConnection()->prepare($sql);

        foreach($stmtParams as $k => $v){
            $query->bindValue($k, $v);

        }
        $res = $query->executeQuery();
        $result_count = $res->fetchAllAssociative();




        $sql = "$select $from $joins $sqlWhere $groupBy $orderBy $limit";
        $query = $this->getEntityManager()->getConnection()->prepare($sql);
        foreach($stmtParams as $k => $v){
            $query->bindValue($k, $v);

        }
        $res = $query->executeQuery();
        $result = $res->fetchAllAssociative();

        /* Data Count */
        $recordsTotal = count($result_count);


              /*
         * Output
         */
        $output = array(
            "draw" => intval($get['draw']),
            "recordsTotal" => $recordsTotal,
            "recordsFiltered" => $recordsTotal,
            "data" => array()
        );

        $url = $get['url'];
        $formUrl = $url . '/client_pet/ajax_detail';  
        $hasUpdate = false;
        $url = $get['url'];
        $hasDelete = false;

        if($userData['type'] == 'Super Admin'|| in_array('Client Pet Details', $userData['accesses'])){
            $hasUpdate = true;
        }

        
        foreach($result as $row) {
           
            $id = base64_encode($row['id']);
           
            $action = $hasUpdate ? ' <a href="javascript:void(0);" class="fullscreen href-modal action-btn action-button-style btn btn-primary table-btn" data-id="'.$id.'"  data-url="'.$formUrl.'" data-action="u">Details</a>' : "";

            $values = array(
                $row['client'],
                $row['clientPet'],
                $action
            );

            $output['data'][] = $values;
        }

        unset($result);
        return $output;
    }

    public function autocompleteSuggestions($q, array $userData) {
       
        $stmtParams = array();

        $qs = $q['query'];

        $where = " WHERE CONCAT(c.`first_name`, ' ', c.`last_name`, ' - ' , cp.`pet_name`) LIKE :description";
        $where .= ' AND c.`branch_id` = "'.base64_decode($userData['branchId']).'"';
        $stmtParams['description'] =  "%$qs%"; 

        $sql = "
            SELECT
                 cp.`id`,
                 CONCAT(c.`first_name`, '  ', c.`last_name`, ' - ' , cp.`pet_name`) AS data,
                 CONCAT(c.`first_name`, '  ', c.`last_name`, ' - ' , cp.`pet_name`) AS value
            FROM `client_pet` cp
            LEFT JOIN `client` c ON c.`id` = cp.`client_id`
            ". $where ."
            AND (cp.`is_deleted` = 0 OR  cp.`is_deleted` IS NULL)            
            ORDER BY CONCAT(c.`first_name`, ' ', c.`last_name`, ' - ' , cp.`pet_name`)
            LIMIT 0,20
        ";


        $query = $this->getEntityManager()->getConnection()->prepare($sql);

        foreach($stmtParams as $k => $v){
            $query->bindValue($k, $v);

        }
       
        $res = $query->executeQuery();
        $result = $res->fetchAllAssociative();

        return $result;
    }

    
}
