<?php

namespace App\Repository;

use App\Entity\GroomingPaymentEntity;
use App\Entity\BranchEntity;


/**
 * GroomingPaymentRepository
 *
 * This class was generated by the Doctrine ORM. Add your own custom
 * repository methods below.
 */
class GroomingPaymentRepository extends \Doctrine\ORM\EntityRepository
{
    public function validate($form) {

        $errors = array();


        $action = $form['action'];

        // d = delete
        if($action !== 'd') {

            if(empty($form['payment_type'])){
                $errors[] = 'Payment Type should not be blank.';
            }

            if(empty($form['payment_date'])){
                $errors[] = 'Payment Date should not be blank.';
            }

            if(empty($form['amount'])){
                $errors[] = 'Amount should not be blank.';
            }
        }

        return $errors;
    }

    public function ajax_list(array $get, array $userData){

        $columns = array(
            array('pt.`description`','pt.`description`', 'paymentType'),
            array('DATE_FORMAT(lp.`payment_date`, "%m/%d/%Y")', 'DATE_FORMAT(lp.`payment_date`, "%m/%d/%Y")', 'paymentDate'),
            array('lp.`amount`', 'lp.`amount`' , ' amt'),
            array('lp.`id`', "lp.`id`", "lpId"),
            array('l.`id`', "l.`id`", "groomingId")
        );
        $asColumns = array();

        $select = "SELECT";
        $from = "FROM `grooming_payment` lp";
        $joins = "LEFT JOIN `payment_type` pt ON pt.`id` = lp.`payment_type_id`";
        $joins .= "LEFT JOIN `grooming` l ON l.`id` = lp.`grooming_id`";

        $sqlWhere = "WHERE lp.`is_deleted` = 0";
        $groupBy = "";
        $orderBy = "";
        $limit = "";
        $stmtParams = array();


        if($userData['type'] != 'Super Admin'){

            $sqlWhere .= " AND l.`branch_id` = :branchId";
            $stmtParams['branchId'] =  base64_decode($userData['branchId']);
        }

        if(isset($get['groomingId'])){

            $sqlWhere .= " AND l.`id` = :groomingId";
            $stmtParams['groomingId'] =  $get['groomingId'];
        }

        foreach($columns as $key => $column) {
            $select .= ($key > 0 ? ', ' : ' ') . $column[1] . (isset($column[2]) ? ' AS ' . $column[2] : '');
        }

        /*
         * Ordering
         */
        foreach($get['columns'] as $key => $column) {
            if($column['orderable']=='true') {
                if(isSet($get['order'])) {
                    foreach($get['order'] as $order) {
                        if($order['column']==$key) {
                            $orderBy .= (!empty($orderBy) ? ', ' : 'ORDER BY ') . $columns[$key][0] . (!empty($order['dir']) ? ' ' . $order['dir'] : '');
                        }
                    }
                }
            }
        }

        /*
         * Filtering
         */
        if(isset($get['search']) && $get['search']['value'] != ''){
            $aLikes = array();
            foreach($get['columns'] as $key => $column) {
                if($column['searchable']=='true') {
                    $aLikes[] = $columns[$key][0] . ' LIKE :searchValue';
                }
            }
            foreach($asColumns as $asColumn) {
                $aLikes[] = $asColumn . ' LIKE :searchValue';
            }
            if(count($aLikes)) {
                $sqlWhere .= (!empty($sqlWhere) ? ' AND ' : 'WHERE ') . '(' . implode(' OR ', $aLikes) . ')';
                $stmtParams['searchValue'] = "%" . $get['search']['value'] . "%";
            }
        }

        /* Set Limit and Length */
        if(isset( $get['start'] ) && $get['length'] != '-1'){
            $limit = 'LIMIT ' . (int)$get['start'] . ',' . (int)$get['length'];
        }

        $sql = "$select $from $joins $sqlWhere $groupBy $orderBy";
        $query = $this->getEntityManager()->getConnection()->prepare($sql);

        foreach($stmtParams as $k => $v){
            $query->bindValue($k, $v);

        }
        $res = $query->executeQuery();
        $result_count = $res->fetchAllAssociative();




        $sql = "$select $from $joins $sqlWhere $groupBy $orderBy $limit";
        $query = $this->getEntityManager()->getConnection()->prepare($sql);
        foreach($stmtParams as $k => $v){
            $query->bindValue($k, $v);

        }
        $res = $query->executeQuery();
        $result = $res->fetchAllAssociative();

        /* Data Count */
        $recordsTotal = count($result_count);


              /*
         * Output
         */
        $output = array(
            "draw" => intval($get['draw']),
            "recordsTotal" => $recordsTotal,
            "recordsFiltered" => $recordsTotal,
            "data" => array()
        );

        $url = $get['url'];
        $formUrl = '';
        $hasUpdate = false;

        if($userData['type'] == 'Super Admin'|| in_array('Grooming Grooming Payment Update', $userData['accesses'])){

            $formUrl = $url . '/grooming_payment/ajax_form';  
            $hasUpdate = true;
        }

        foreach($result as $row) {

            $id = $row['lpId'];

            $action = $hasUpdate ? '<a href="javascript:void(0);" class="href-modal action-btn action-button-style btn btn-primary href-form" data-groomingid="'.$row["groomingId"].'" data-id="'.$id.'"  data-url="'.$formUrl.'" data-action="u">Update</a>' : "";

            $values = array(
                $row['paymentType'],
                $row['paymentDate'],
                number_format($row['amt'],2, '.' , ','),
                $action
            );

            $output['data'][] = $values;
        }

        unset($result);

        return $output;
    }

    public function autocomplete_suggestions($q, array $userData) {
       
        $stmtParams = array();

        $qs = $q['query'];

        $where = ' WHERE b.`description` LIKE :description';
        $stmtParams['description'] =  "%$qs%"; 

        if($userData['type'] != 'Super Admin' ){

            $where.= ' AND b.`branch_id` = :branchId';
            $stmtParams['branchId'] = base64_decode($userData['branchId']);
        }
      
        $sql = "
            SELECT
                 b.`id`,
                 b.`description` AS data,
                 b.`description` AS value
            FROM `room` b
            ". $where ."
            AND b.`is_deleted` = 0
            ORDER BY b.`description`
            LIMIT 0,20
        ";


        $query = $this->getEntityManager()->getConnection()->prepare($sql);

        foreach($stmtParams as $k => $v){
            $query->bindValue($k, $v);

        }
       
        $res = $query->executeQuery();
        $result = $res->fetchAllAssociative();

        return $result;
    }

    public function report($data, array $userData) {

        
        $where = '';
      
        if(isset($userData['branchId'])){
            $where .= ' WHERE c.`branch_id` = ' .base64_decode($userData['branchId']);
        }

        if(!empty($data['date_from']) && !empty($data['date_to'])){

            $where .= ' AND lp.`payment_date` BETWEEN "' .date('Y-m-d' , strtotime($data['date_from'])) . ' 00:00:00"  AND  "' . date('Y-m-d' , strtotime( $data['date_to'])) . ' 23:59:59 "';  
        } else if(!empty($data['date_from'])){
            $where .= ' AND lp.`payment_date` >="' .date('Y-m-d' , strtotime($data['date_from'])) . ' 00:00:00"';  

        } else if(!empty($data['date_to'])){
            $where .= ' AND lp.`payment_date` <="' .date('Y-m-d' , strtotime($data['date_to'])) . ' 23:59:59"';  

        }
         
        $sql = "
            SELECT
                CONCAT(c.`first_name` , ' ', c.`last_name`) AS client,
                DATE_FORMAT(lp.`payment_date`, '%m/%d/%Y') AS paymentDate,
                pt.`description` AS paymentType,
                lp.`amount` AS amount
            FROM `grooming_payment` lp
            LEFT JOIN `grooming` l ON l.`id` = lp.`grooming_id`
            LEFT JOIN `client_pet` cp ON cp.`id` = l.`client_pet_id`
            LEFT JOIN `client` c ON c.`id` = cp.`client_id`
            LEFT JOIN `payment_type` pt ON pt.`id` = lp.`payment_type_id`
            ".$where."
           
        ";

        $query = $this->getEntityManager()->getConnection()->prepare($sql);

       
        $res = $query->executeQuery();
        $result = $res->fetchAllAssociative();
        return $result;
    }


  

}
