<?php

namespace App\Repository;

use App\Entity\SmsEntity;

/**
 * SmsRepository
 *
 * This class was generated by the Doctrine ORM. Add your own custom
 * repository methods below.
 */
class SmsRepository extends \Doctrine\ORM\EntityRepository
{

    public function validate($sms_form) {

        $errors = array();

        $action = $sms_form['action'];

        // d = delete
        if($action !== 'd') {

            $smsExist = $this->getEntityManager()->getRepository(SmsEntity::class)
                ->createQueryBuilder('u')
                ->where('u.id != :id')
                ->andWhere('u.company = :company')
                ->setParameters(array(
                    'id' => $sms_form['id'],
                    'company' => $sms_form['company']
                ))
                ->getQuery()->getResult();

            if($smsExist) {
                $errors[] = 'Sms already exist.';
            }



          
        }

        return $errors;
    }

    public function ajax_list(array $get, $userData){

        $columns = array(
            array('u.`message`', 'u.`message`' , "message"),
            array('u.`id`', "u.`id`"),
            array('u.`company_id`', "u.`company_id`")

        );
        $asColumns = array();

        $select = "SELECT";
        $from = "FROM `sms` u";
        $joins = "";
        $sqlWhere = "";
        $groupBy = "";
        $orderBy = "";
        $limit = "";
        $stmtParams = array();

        foreach($columns as $key => $column) {
            $select .= ($key > 0 ? ', ' : ' ') . $column[1] . (isset($column[2]) ? ' AS ' . $column[2] : '');
        }


        if($userData['type'] != 'Super Admin' || $get['companyId']){

            $sqlWhere .= " WHERE u.`company_id` = :companyId";
            $stmtParams['companyId'] = base64_decode($get['companyId']);
        }

        /*
         * Ordering
         */
        foreach($get['columns'] as $key => $column) {
            if($column['orderable']=='true') {
                if(isSet($get['order'])) {
                    foreach($get['order'] as $order) {
                        if($order['column']==$key) {
                            $orderBy .= (!empty($orderBy) ? ', ' : 'ORDER BY ') . $columns[$key][0] . (!empty($order['dir']) ? ' ' . $order['dir'] : '');
                        }
                    }
                }
            }
        }

        /*
         * Filtering
         */
        if(isset($get['search']) && $get['search']['value'] != ''){
            $aLikes = array();
            foreach($get['columns'] as $key => $column) {
                if($column['searchable']=='true') {
                    $aLikes[] = $columns[$key][0] . ' LIKE :searchValue';
                }
            }
            foreach($asColumns as $asColumn) {
                $aLikes[] = $asColumn . ' LIKE :searchValue';
            }
            if(count($aLikes)) {
                $sqlWhere .= (!empty($sqlWhere) ? ' AND ' : 'WHERE ') . '(' . implode(' OR ', $aLikes) . ')';
                $stmtParams['searchValue'] = "%" . $get['search']['value'] . "%";
            }
        }

        /* Set Limit and Length */
        if(isset( $get['start'] ) && $get['length'] != '-1'){
            $limit = 'LIMIT ' . (int)$get['start'] . ',' . (int)$get['length'];
        }

        $sql = "$select $from $joins $sqlWhere $groupBy $orderBy";
        $query = $this->getEntityManager()->getConnection()->prepare($sql);
     

        foreach($stmtParams as $k => $v){
            $query->bindValue($k, $v);

        }
        $res = $query->executeQuery();
        $result_count = $res->fetchAllAssociative();




        $sql = "$select $from $joins $sqlWhere $groupBy $orderBy $limit";
        $query = $this->getEntityManager()->getConnection()->prepare($sql);
        foreach($stmtParams as $k => $v){
            $query->bindValue($k, $v);

        }
        $res = $query->executeQuery();
        $result = $res->fetchAllAssociative();

        /* Data Count */
        $recordsTotal = count($result_count);

        /*
         * Output
         */
        $output = array(
            "draw" => intval($get['draw']),
            "recordsTotal" => $recordsTotal,
            "recordsFiltered" => $recordsTotal,
            "data" => array()
        );

        $url = $get['url'];
        $formUrl = '';
        $hasUpdate = false;
        if($userData['type'] == 'Super Admin'  || in_array('Company View Sms Update', $userData['accesses'])){

            $formUrl = $url . 'sms/ajax_form';  
            $hasUpdate = true;
        }

        if($userData['type'] == 'Super Admin'|| in_array('Room Update', $userData['accesses'])){

            $formUrl = $url . '/admin/sms/ajax_form';  
            $hasUpdate = true;
        }

        foreach($result as $row) {

            $id = base64_encode($row['id']);
            $companyId = base64_encode($row['company_id']);


            $action = $hasUpdate ? '<a href="javascript:void(0);" class="href-modal action-btn action-button-style btn btn-primary table-btn" data-id="'.$id.'"  data-companyid="'.$companyId.'" data-url="'.$formUrl.'" data-action="u">Update</a>' : "";

            $values = array(
                $row['message'],
                $action
            );

            $output['data'][] = $values;
        }

        unset($result);

        return $output;
    }
    
    
}
